package com.ca.dso.itpam.webservice.client;


import java.util.Date;
import java.util.Iterator;
import java.util.Properties;

import org.apache.axis2.databinding.types.Time;
import org.apache.axis2.databinding.types.URI;
import org.apache.axis2.databinding.types.URI.MalformedURIException;

import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.ActionOnInstance;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.Attachment;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.Attachments;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.Auth;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.CheckFlowResponse;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.CheckFlowResult;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.CheckStartRequestStatus;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.CheckStartRequestStatusChoice_type0;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.CheckStartRequestStatusResponse;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.ControlInstance;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.ControlInstanceChoice_type0;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.ControlInstanceResponse;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.Execflow;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.ExecflowChoice_type0;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.ExecuteC2OFlowResponse;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.ExecuteProcess;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.ExecuteStartRequest;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.ExecuteStartRequestResponse;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.Flow;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.GetITPamVersion;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.GetProcessStatus;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.ITPamVersionDetails;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.Id;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.ImportFileParam;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.ImportFileParamE;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.Name;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.ObjLocation;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.Options;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.OverwriteAction;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.Param;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.Params;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.Priority;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.StartDate;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.StartRequestStatus;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.StartTime;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.SwaRef;
import com.ca.dso.itpam.webservice.stub_4_2.ItpamServiceStub.UserAuth;

public class ItpamWebServiceClient_4_0 extends ItpamWebServiceClient_3_0{

	/**	Private version specific authentication object																	*/
	protected Auth m_auth_40 = null;

	/**	Private version specific web service stub object																*/
	protected ItpamServiceStub m_stubItpamService_40 = null;

	/**	Private version specific user authentication object																*/
	protected UserAuth m_userAuth_40;	


	public ItpamWebServiceClient_4_0(String strTargetEndpointVersion,
			String strTargetEndpointURI, String strUser, String strPassword)
	throws Exception, ItpamMethodNotSupportedException,
	ItpamParameterMissingOrInvalidException,
	ItpamStringToDateException, ItpamEntityNotFoundException,
	ItpamUserPermissionsException, ItpamUnknownHostException,
	ItpamWebServiceClientException {

		super(strTargetEndpointVersion, strTargetEndpointURI, strUser, strPassword);

		init40CommonObjects(strTargetEndpointURI, strUser, strPassword);
	}

	/**
	 * Get current status of the ITPAM web service server.
	 * 
	 * @return String set to server status
	 * 
	 * @throws ItpamMethodNotSupportedException
	 * @throws ItpamParameterMissingOrInvalidException
	 * @throws ItpamStringToDateException
	 * @throws ItpamEntityNotFoundException
	 * @throws ItpamUserPermissionsException
	 * @throws ItpamUnknownHostException
	 * @throws ItpamWebServiceClientException
	 */
	public String getITPamVersionInfo()
	throws Exception, ItpamMethodNotSupportedException, ItpamParameterMissingOrInvalidException, ItpamStringToDateException,
	ItpamEntityNotFoundException, ItpamUserPermissionsException, ItpamUnknownHostException, ItpamWebServiceClientException
	{

		String strServerVersion = null;

		try {

			GetITPamVersion request = new GetITPamVersion();		
			request.setAuth(this.m_auth_40);

			ITPamVersionDetails response = this.m_stubItpamService_40.getITPamVersionInfo(request);

			if(response.getMajorVersion() != null && response.getMajorVersion().length() > 0) {
				strServerVersion = response.getMajorVersion();
			}

			if(response.getMinorVersion() != null && response.getMinorVersion().length() > 0) {
				strServerVersion = strServerVersion + "." + response.getMinorVersion();
			}
		} 
		catch (Exception e) {

			try {
				//	Initialize exception messages
				String strMessage = this._messages.get("E_METHOD_GET_VERSION_INFO");
				String strLocalizedMessage = this._messages.getLocalized("E_METHOD_GET_VERSION_INFO");

				//	Get type specific exception
				e = this.getTypeSpecificException(e, strMessage, strLocalizedMessage);
			}
			catch (Exception eUnexpected){

				e = eUnexpected;
			}

			//	Record exception
			ItpamWebServiceClient.logger.error(e.getMessage());

			//	Throw specific exception type
			throw(e);
		}	

		return strServerVersion;
	}

	/**
	 * Import ITPAM object defined in specified XML file.
	 * 
	 * @param strSourcePathFileName - String set to path and file name of file to be imported
	 * @param strTargetLibraryPathName - String set to target library path and object name
	 * @param bolMakeCurrent - boolean set to true if imported file should be flagged as the current version
	 * 
	 * @throws ItpamMethodNotSupportedException
	 * @throws ItpamParameterMissingOrInvalidException
	 * @throws ItpamStringToDateException
	 * @throws ItpamEntityNotFoundException
	 * @throws ItpamUserPermissionsException
	 * @throws ItpamUnknownHostException
	 * @throws ItpamWebServiceClientException
	 */
	public void importObject(String strSourcePathFileName, String strTargetLibraryPathName, boolean bolMakeAvailable, boolean bolMakeCurrent, String strOverwriteAction)
	throws Exception, ItpamMethodNotSupportedException, ItpamParameterMissingOrInvalidException, ItpamStringToDateException,
	ItpamEntityNotFoundException, ItpamUserPermissionsException, ItpamUnknownHostException, ItpamWebServiceClientException
	{

		try {

			logger.debug("Calling importObject against PAM 4.0 stubs, overwriteAction input is taken into account.");
			//	Initialize file parameter object
			ImportFileParam file = new ImportFileParam();
			file.setAuth(m_auth_40);
			file.setImportLocation(strTargetLibraryPathName);
			file.setLocalSourceLocation(strSourcePathFileName);
			file.setIsMakeAvailable(bolMakeAvailable);
			file.setIsSetCurrent(bolMakeCurrent);

			OverwriteAction overWriteAction = OverwriteAction.Factory.fromValue(strOverwriteAction);
			file.setOverwriteAction(overWriteAction);

			//	Initialize request object
			ImportFileParamE request = new ImportFileParamE();
			request.setImportFileParam(file);

			//	Initiate web service request
			this.m_stubItpamService_40.importObject(request);

			//	Record success
			String strMessage = "Successfully completed request to import file " + strSourcePathFileName + "'";
			ItpamWebServiceClient.logger.info(strMessage);

		}
		catch (Exception e) {

			try {
				//	Initialize exception messages
				String strMessage = this._messages.get("E_METHOD_IMPORT_OBJECT")
				+ " (" + strSourcePathFileName + ")";
				String strLocalizedMessage = this._messages.getLocalized("E_METHOD_IMPORT_OBJECT")
				+ " (" + strSourcePathFileName + ")";

				//	Get type specific exception
				e = this.getTypeSpecificException(e, strMessage, strLocalizedMessage);
			}
			catch (Exception eUnexpected){

				e = eUnexpected;
			}

			//	Record exception
			ItpamWebServiceClient.logger.error(e.getMessage());

			//	Throw specific exception type
			throw(e);
		}
	}

	/**
	 * Initialize common class level objects.
	 * 
	 * @throws ItpamMethodNotSupportedException
	 * @throws ItpamParameterMissingOrInvalidException
	 * @throws ItpamStringToDateException
	 * @throws ItpamEntityNotFoundException
	 * @throws ItpamUserPermissionsException
	 * @throws ItpamUnknownHostException
	 * @throws ItpamWebServiceClientException
	 */
	private void init40CommonObjects(String strTargetEndpointURI, String strUser, String strPassword)
	throws Exception, ItpamMethodNotSupportedException, ItpamParameterMissingOrInvalidException, ItpamStringToDateException,
	ItpamEntityNotFoundException, ItpamUserPermissionsException, ItpamUnknownHostException, ItpamWebServiceClientException
	{		
		//	Record progress
		ItpamWebServiceClient.logger.debug("Initializing web service client common objects");

		try {

			//	Initialize web service stub
			this.m_stubItpamService_40 = new ItpamServiceStub(this._strTargetEndpointURI);

			//	Initialize user authentication object
			UserAuth userAuth = new UserAuth();
			userAuth.setPassword(this._strPassword);
			userAuth.setUser(this._strUser);

			//	Initialize authentication object
			this.m_auth_40 = new Auth();
			this.m_auth_40.setUserAuth(userAuth);	
		}
		catch (Exception e){

			//	Set exception messages
			String strMessage = this._messages.get("E_METHOD_INIT_COMMON_OBJECTS");
			String strLocalizedMessage = this._messages.getLocalized("E_METHOD_INIT_COMMON_OBJECTS");

			//	Record exception
			ItpamWebServiceClient.logger.error(strMessage);

			//	Throw exception
			throw new ItpamParameterMissingOrInvalidException(strMessage, strLocalizedMessage);
		}

		//	Record progress
		ItpamWebServiceClient.logger.debug("Initialized web service client common objects");
	}


	/**
	 * Convert POJO Strings set to start date and time to ITPAM version specific Options object
	 * 
	 * @param strStartDate - String set to start date ('yyyy-MM-dd', 'yyyy/MM/dd', 'MM-dd-yyyy', 'MM/dd/yyyy')
	 * @param strStartTime - String set to time ('hh:mm:ss', 'hh:mm')
	 * @param tagId - String set to the tag id
	 * @param isAutoArchive - Boolean set to true/false
	 * @param priority - String set the priority
	 * 
	 * @return version specific ITPAM Options object with start date and/or time set to values specified
	 * 
	 * @throws ItpamMethodNotSupportedException
	 * @throws ItpamParameterMissingOrInvalidException
	 * @throws ItpamStringToDateException
	 * @throws ItpamEntityNotFoundException
	 * @throws ItpamUserPermissionsException
	 * @throws ItpamUnknownHostException
	 * @throws ItpamWebServiceClientException
	 */
	private Options getInstanceOfOptions(String strStartDate, String strStartTime, String tagId, Boolean isAutoArchive, String priority)
	throws Exception, ItpamMethodNotSupportedException, ItpamParameterMissingOrInvalidException, ItpamStringToDateException,
	ItpamEntityNotFoundException, ItpamUserPermissionsException, ItpamUnknownHostException, ItpamWebServiceClientException
	{

		//	Throw exception if invalid or missing parameters detected otherwise attempt to create object
		if ((this.isNullEmpty(strStartDate)) && (!this.isNullEmpty(strStartTime))){

			//	Set exception messages
			String strMessage = this._messages.get("E_MISSING_OR_INVALID_PARAMETER")
			+ " (startDate)";
			String strLocalizedMessage = this._messages.getLocalized("E_MISSING_OR_INVALID_PARAMETER")
			+ " (startDate)";

			//	Record exception
			ItpamWebServiceClient.logger.error(strMessage);

			//	Throw exception
			throw new ItpamParameterMissingOrInvalidException(strMessage, strLocalizedMessage);
		}

		//	Initialize options object
		Options options = null;
		options = new Options();

		//	Set Start Date if applicable
		if (!isNullEmpty(strStartDate)) {
			Date date = this.getDateFromString(strStartDate);
			StartDate startDate = new StartDate();
			startDate.setStartDate(date);
			options.setStartDate(startDate);
		}

		//	Set start time if applicable
		if (!isNullEmpty(strStartTime)) {
			Time time = new Time(strStartTime);
			StartTime startTime = new StartTime();
			startTime.setStartTime(time);
			options.setStartTime(startTime);
		}

		// Set tagId if applicable
		if (!isNullEmpty(tagId)) {
			options.setTagId(tagId);
		}

		// Set isAutoArchive if applicable
		if (isAutoArchive != null) {
			options.setIsAutoArchive(isAutoArchive);
		}

		// Set priority if applicable
		if (!isNullEmpty(priority)) {
			options.setPriority(Priority.Factory.fromString(priority, ""));
		}

		//	Return options object
		return options;
	}	

	/**
	 * Execute specified process.
	 * 
	 * @param strProcessName - String set to fully qualified process name
	 * @param propertiesParameters - Properties object encapsulating parameter names and values or null
	 * @param strStartDate - String set to start date ('yyyy-MM-dd', 'yyyy/MM/dd', 'MM-dd-yyyy', 'MM/dd/yyyy') or null. Required if
	 * parameter 'strStartTime' is specified
	 * @param strStartTime - String set to time ('hh:mm:ss', 'hh:mm') or null
	 * @param tagId - String tag ID
	 * @param isAutoArchive - Boolean 
	 * @param priority - String
	 * @param strParameterNameAttachments - String set to parameter name attachments will be linked or null. Required if attachment
	 * properties are specified.
	 * @param propertiesAttachments - Properties object encapsulating attachment name and URI name/value pairs
	 * 
	 * @return String set to process ID
	 * 
	 * @throws ItpamMethodNotSupportedException
	 * @throws ItpamParameterMissingOrInvalidException
	 * @throws ItpamStringToDateException
	 * @throws ItpamEntityNotFoundException
	 * @throws ItpamUserPermissionsException
	 * @throws ItpamUnknownHostException
	 * @throws ItpamWebServiceClientException
	 */
	private long executeProcess(String strProcessName,
			String strAction,
			Properties propertiesParameters,
			String strStartDate, String strStartTime, String tagId, Boolean isAutoArchive, String priority, 
			String strParameterNameAttachments, Properties propertiesAttachments)
	throws Exception, ItpamMethodNotSupportedException, ItpamParameterMissingOrInvalidException, ItpamStringToDateException,
	ItpamEntityNotFoundException, ItpamUserPermissionsException, ItpamUnknownHostException, ItpamWebServiceClientException
	{
		//	Initialize return value
		long lProcessId;

		try {

			//	Initialize name object
			Name name = this.getInstanceOfName(strProcessName);	

			//	Initialize attachments object
			Attachments attachments = this.getInstanceOfAttachments(strParameterNameAttachments, propertiesAttachments);

			//	Initialize options object
			Options options = this.getInstanceOfOptions(strStartDate, strStartTime, tagId, isAutoArchive, priority);

			//	Initialize parameters object
			Params parameters = this.getInstanceOfParameters(propertiesParameters);

			//	Initialize flow object
			Flow flow = new Flow();
			flow.setAction(strAction);
			flow.setAttachments(attachments);
			flow.setAuth(m_auth_40);
			flow.setName(name.getName());
			flow.setOptions(options);
			flow.setParams(parameters);

			//	Initialize request object
			ExecuteProcess request = new ExecuteProcess();
			request.setFlow(flow);

			//	Initiate web service request
			ExecuteC2OFlowResponse response = this.m_stubItpamService_40.executeProcess(request);

			//	Update return value
			lProcessId = Long.parseLong(response.getExecuteC2OFlowResult().getROID());

			//	Record success
			String strMessage = "Successfully completed request to '" + strAction + "' process '" + this._strProcessName + "' "
			+ " process ID " + lProcessId;
			ItpamWebServiceClient.logger.info(strMessage);
		}
		catch (Exception e) {

			try {
				//	Initialize exception messages
				String strMessage = this._messages.get("E_METHOD_EXECUTE_PROCESS")
				+ " (" + strProcessName + ")";
				String strLocalizedMessage = this._messages.getLocalized("E_METHOD_EXECUTE_PROCESS")
				+ " (" + strProcessName + ")";

				//	Get type specific exception
				e = this.getTypeSpecificException(e, strMessage, strLocalizedMessage);
			}
			catch (Exception eUnexpected){

				e = eUnexpected;
			}

			//	Record exception
			ItpamWebServiceClient.logger.error(e.getMessage());

			//	Throw specific exception type
			throw(e);
		}

		//	Return value
		return lProcessId;
	}

	/**
	 * Initiate process via start request form.
	 * 
	 * @param strName - String set to start request form name
	 * @param strPath - String set to start request form library path
	 * @param propertiesParameters - Properties object encapsulating parameter names and values or null
	 * @param strStartDate - String set to start date ('yyyy-MM-dd', 'yyyy/MM/dd', 'MM-dd-yyyy', 'MM/dd/yyyy') or null
	 * @param strStartTime - String set to time ('hh:mm:ss', 'hh:mm') or null
	 * @param tagId - String tag ID
	 * @param isAutoArchive - Boolean 
	 * @param priority - String
	 * @param strParameterNameAttachments - String set to parameter name attachments will be linked or null. Required if attachment
	 * properties are specified.
	 * @param propertiesAttachments - Properties object encapsulating attachment name and URI name/value pairs
	 * 
	 * @return long process ID value
	 * 
	 * @throws ItpamEntityNotFoundException
	 * @throws ItpamMethodNotSupportedException
	 * @throws ItpamParameterMissingOrInvalidException
	 * @throws ItpamStringToDateException
	 * @throws ItpamUnknownHostException
	 * @throws ItpamUserPermissionsException
	 * @throws ItpamWebServiceClientException
	 */
	public long startRequest(String strName, String strPath, Properties propertiesParameters,
			String strStartDate, String strStartTime,
			String tagId, Boolean isAutoArchive, String priority, 
			String strParameterNameAttachments, Properties propertiesAttachments)
	throws Exception, ItpamMethodNotSupportedException, ItpamParameterMissingOrInvalidException, ItpamStringToDateException,
	ItpamEntityNotFoundException, ItpamUserPermissionsException, ItpamUnknownHostException, ItpamWebServiceClientException {
		//	Record progress
		ItpamWebServiceClient.logger.debug("Calling startRequest against PAM 4.0 stubs, input: tagId, isAutoArchive, and priority are taken into account.");
		ItpamWebServiceClient.logger.debug("Start request '" + strName + "'");

		return this.executeStartRequest(strName, strPath,
				propertiesParameters, strStartDate, strStartTime,
				tagId, isAutoArchive, priority, 
				strParameterNameAttachments, propertiesAttachments);
	}

	/**
	 * Start process specified.
	 * 
	 * @param strProcessName - String set to fully qualified process name
	 * @param propertiesParameters - Properties object encapsulating parameter names and values or null
	 * @param strStartDate - String set to start date ('yyyy-MM-dd', 'yyyy/MM/dd', 'MM-dd-yyyy', 'MM/dd/yyyy') or null. Required if
	 * parameter 'strStartTime' is specified
	 * @param strStartTime - String set to time ('hh:mm:ss', 'hh:mm') or null
	 * @param tagId - String tag ID
	 * @param isAutoArchive - Boolean 
	 * @param priority - String
	 * @param strParameterNameAttachments - String set to parameter name attachments will be linked or null. Required if attachment
	 * properties are specified.
	 * @param propertiesAttachments - Properties object encapsulating attachment name and URI name/value pairs
	 * 
	 * @return long set to process ID value
	 * 
	 * @throws ItpamMethodNotSupportedException
	 * @throws ItpamParameterMissingOrInvalidException
	 * @throws ItpamStringToDateException
	 * @throws ItpamEntityNotFoundException
	 * @throws ItpamUserPermissionsException
	 * @throws ItpamUnknownHostException
	 * @throws ItpamWebServiceClientException
	 */
	public long startProcess(String strProcessName,
			Properties propertiesParameters,
			String strStartDate, String strStartTime,
			String tagId, Boolean isAutoArchive, String priority, 
			String strParameterNameAttachments, Properties propertiesAttachments)
	throws Exception, ItpamMethodNotSupportedException, ItpamParameterMissingOrInvalidException, ItpamStringToDateException,
	ItpamEntityNotFoundException, ItpamUserPermissionsException, ItpamUnknownHostException, ItpamWebServiceClientException
	{
		//	Record progress
		ItpamWebServiceClient.logger.debug("Calling startProcess against PAM 4.0 stubs, input: tagId, isAutoArchive, and priority are taken into account.");
		ItpamWebServiceClient.logger.debug("Start process '" + strProcessName + "'");

		//	Set action
		String strAction = "Start";

		//	Invoke method to execute process
		return this.executeProcess(strProcessName, strAction, propertiesParameters, strStartDate, strStartTime, tagId, isAutoArchive, priority, strParameterNameAttachments, propertiesAttachments);
	}	
	/**
	 * Initiate process via start request form.
	 * 
	 * @param strStartRequestName - String set to start request form name
	 * @param strStartRequestPath - String set to start request form library path
	 * @param propertiesParameters - Properties object encapsulating parameter names and values or null
	 * @param strStartDate - String set to start date ('yyyy-MM-dd', 'yyyy/MM/dd', 'MM-dd-yyyy', 'MM/dd/yyyy') or null
	 * @param strStartTime - String set to time ('hh:mm:ss', 'hh:mm') or null
	 * @param tagId - String tag ID
	 * @param isAutoArchive - Boolean 
	 * @param priority - String
	 * @param strParameterNameAttachments - String set to parameter name attachments will be linked or null. Required if attachment
	 * properties are specified.
	 * @param propertiesAttachments - Properties object encapsulating attachment name and URI name/value pairs
	 * 
	 * @return String set to process ID
	 * 
	 * @throws ItpamMethodNotSupportedException
	 * @throws ItpamParameterMissingOrInvalidException
	 * @throws ItpamStringToDateException
	 * @throws ItpamEntityNotFoundException
	 * @throws ItpamUserPermissionsException
	 * @throws ItpamUnknownHostException
	 * @throws ItpamWebServiceClientException
	 */
	private long executeStartRequest(String strStartRequestName, String strStartRequestPath,
			Properties propertiesParameters, String strStartDate, String strStartTime,
			String tagId, Boolean isAutoArchive, String priority, 
			String strParameterNameAttachments, Properties propertiesAttachments)
	throws Exception, ItpamMethodNotSupportedException, ItpamParameterMissingOrInvalidException, ItpamStringToDateException,
	ItpamEntityNotFoundException, ItpamUserPermissionsException, ItpamUnknownHostException, ItpamWebServiceClientException
	{
		//	Initialize return value
		long lStartRequestInteractionId;

		try {

			//	Initialize attachments object
			Attachments attachments = this.getInstanceOfAttachments(strParameterNameAttachments, propertiesAttachments);

			//	Initialize location object
			ObjLocation location = this.getInstanceOfLocation(strStartRequestName, strStartRequestPath);

			//	Initialize options object
			Options options = this.getInstanceOfOptions(strStartDate, strStartTime, tagId, isAutoArchive, priority);

			//	Initialize parameters object
			Params parameters = this.getInstanceOfParameters(propertiesParameters);

			//	Initialize request object
			ExecuteStartRequest request = new ExecuteStartRequest();
			request.setAttachments(attachments);
			request.setAuth(this.m_auth_40);
			request.setObjLocation(location);
			request.setOptions(options);
			request.setParams(parameters);

			//	Initiate web service request
			ExecuteStartRequestResponse response = this.m_stubItpamService_40.executeStartRequest(request);

			//	Update return value
			lStartRequestInteractionId = response.getStartRequestStatus().getInteractionId();

			//	Record progress
			String strMessage = "Successfully completed request to 'Start' start request " + location.getPath() + location.getName() + " start request interaction ID " + lStartRequestInteractionId;
			if (!this.getParametersList(parameters).equals("")) {

				strMessage = strMessage + " (";
				strMessage = strMessage + this.getParametersList(parameters);
				strMessage = strMessage + ")";
			}
			ItpamWebServiceClient.logger.info(strMessage);
		}
		catch (Exception e) {

			try {
				//	Initialize exception messages
				String strMessage = this._messages.get("E_METHOD_EXECUTE_START_REQUEST")
				+ " (" + this._strStartRequestName + ", " + this._strStartRequestPath + ")";
				String strLocalizedMessage = this._messages.getLocalized("E_METHOD_EXECUTE_START_REQUEST")
				+ " (" + this._strStartRequestName + ", " + this._strStartRequestPath + ")";

				//	Get type specific exception
				e = this.getTypeSpecificException(e, strMessage, strLocalizedMessage);
			}
			catch (Exception eUnexpected){

				e = eUnexpected;
			}

			//	Record exception
			ItpamWebServiceClient.logger.error(e.getMessage());

			//	Throw specific exception type
			throw(e);
		}

		//	Return value
		return lStartRequestInteractionId;
	}

	/**
	 * Convert POJO Strings set to start date and time to ITPAM version specific Options object
	 * 
	 * @param strProcessName - String set to fully qualified process name
	 * 
	 * @return version specific ITPAM Name object
	 * 
	 * @throws ItpamMethodNotSupportedException
	 * @throws ItpamParameterMissingOrInvalidException
	 * @throws ItpamStringToDateException
	 * @throws ItpamEntityNotFoundException
	 * @throws ItpamUserPermissionsException
	 * @throws ItpamUnknownHostException
	 * @throws ItpamWebServiceClientException
	 */
	private Name getInstanceOfName(String strProcessName)
	throws Exception, ItpamMethodNotSupportedException, ItpamParameterMissingOrInvalidException, ItpamStringToDateException,
	ItpamEntityNotFoundException, ItpamUserPermissionsException, ItpamUnknownHostException, ItpamWebServiceClientException
	{
		//	Initialize return object
		Name name = new Name();

		//	Throw exception if missing or invalid detected otherwise update return object
		if (this.isNullEmpty(strProcessName)){

			//	Set process name
			this._strProcessName = "?";

			//	Set exception messages
			String strMessage = this._messages.get("E_MISSING_OR_INVALID_PARAMETER")
			+ " (processName)";
			String strLocalizedMessage = this._messages.getLocalized("E_MISSING_OR_INVALID_PARAMETER")
			+ " (processName)";;

			//	Record exception
			ItpamWebServiceClient.logger.error(strMessage);

			//	Throw exception
			throw new ItpamParameterMissingOrInvalidException(strMessage, strLocalizedMessage);
		}
		else {

			//	Set process name
			this._strProcessName = strProcessName;

			//	Update object
			name.setName(strProcessName);
		}

		//	Return location object
		return name;
	}

	/**
	 * Convert POJO String and Properties objects to ITPAM version specific Attachments object
	 * 
	 * @param strParameterName - String set to parameter name attachments will be linked to
	 * @param propertiesAttachemsnts - Properties object encapsulating attachment name and URI name/value pairs
	 * 
	 * @return version specific ITPAM Attachments object
	 * 
	 * @throws ItpamMethodNotSupportedException
	 * @throws ItpamParameterMissingOrInvalidException
	 * @throws ItpamStringToDateException
	 * @throws ItpamEntityNotFoundException
	 * @throws ItpamUserPermissionsException
	 * @throws ItpamUnknownHostException
	 * @throws ItpamWebServiceClientException
	 */
	private Attachments getInstanceOfAttachments(String strParameterName, Properties propertiesAttachments)
	throws Exception, ItpamMethodNotSupportedException, ItpamParameterMissingOrInvalidException, ItpamStringToDateException,
	ItpamEntityNotFoundException, ItpamUserPermissionsException, ItpamUnknownHostException, ItpamWebServiceClientException
	{

		//	Instantiate attachments object
		Attachments attachments = null;

		//	Determine if valid parameters specified
		if ((this.isNullEmpty(strParameterName)) && (propertiesAttachments != null)){

			//	Set exception messages
			String strMessage = this._messages.get("E_MISSING_OR_INVALID_PARAMETER")
			+ " (attachmentParameterName)";
			String strLocalizedMessage = this._messages.getLocalized("E_MISSING_OR_INVALID_PARAMETER")
			+ " (attachmentParameterName)";

			//	Record exception
			ItpamWebServiceClient.logger.error(strMessage);

			//	Throw exception
			throw new ItpamParameterMissingOrInvalidException(strMessage, strLocalizedMessage);	
		}
		else if ((!this.isNullEmpty(strParameterName)) && (propertiesAttachments == null)){

			//	Set exception messages
			String strMessage = this._messages.get("E_MISSING_OR_INVALID_PARAMETER")
			+ " (Attachment Properties)";
			String strLocalizedMessage = this._messages.getLocalized("E_MISSING_OR_INVALID_PARAMETER")
			+ " (Attachment Properties)";

			//	Record exception
			ItpamWebServiceClient.logger.error(strMessage);

			//	Throw exception
			throw new ItpamParameterMissingOrInvalidException(strMessage, strLocalizedMessage);				
		}
		else if (  (!this.isNullEmpty(strParameterName))
				&& (propertiesAttachments != null)
				&& (propertiesAttachments.size() > 0))
		{

			try {

				//	Initialize attachments object	
				attachments = new Attachments();
				attachments.setAttachmentsParamName(strParameterName);

				//	Iterate and add attachments
				for (Iterator<Object> iAttachments = propertiesAttachments.keySet().iterator(); iAttachments.hasNext();){

					//	Initialize attachment and SOAP with attachments reference objects					
					Attachment attachment = new Attachment();					
					SwaRef swaref = new SwaRef();					

					//	Get/set attachment ID, name and source location
					String strAttachmentName = (String) iAttachments.next();
					String strAttachmentSourceLocation = propertiesAttachments.getProperty(strAttachmentName);
					swaref.setSwaRef(new URI("cid:" + strAttachmentName));

					//	Set attachment properties
					attachment.setAttachmentID(swaref);
					attachment.setName(strAttachmentName);
					attachment.setLocalSourceLocation(strAttachmentSourceLocation);

					//	Add attachment to attachments object
					attachments.addAttachment(attachment);
				}
			}
			catch (MalformedURIException e) {

				//	Set exception messages
				String strMessage = this._messages.get("E_MISSING_OR_INVALID_URI")
				+ " (Attachment Properties)";
				String strLocalizedMessage = this._messages.getLocalized("E_MISSING_OR_INVALID_URI")
				+ " (Attachment Properties)";

				//	Record exception
				ItpamWebServiceClient.logger.error(strMessage);

				//	Throw exception
				throw new ItpamParameterMissingOrInvalidException(strMessage, strLocalizedMessage);
			}
		}

		//	Return attachment object
		return attachments;
	}

	/**
	 * Convert POJO Properties object to ITPAM version specific Params object
	 * 
	 * @param properties - Properties object encapsulating parameter names and values
	 * 
	 * @return version specific ITPAM Params object with parameters set to parameter names and values
	 * encapsulated in the specified Properties object
	 * 
	 * @throws ItpamMethodNotSupportedException
	 * @throws ItpamParameterMissingOrInvalidException
	 * @throws ItpamStringToDateException
	 * @throws ItpamEntityNotFoundException
	 * @throws ItpamUserPermissionsException
	 * @throws ItpamUnknownHostException
	 * @throws ItpamWebServiceClientException
	 */
	private Params getInstanceOfParameters(Properties properties)
	throws Exception, ItpamMethodNotSupportedException, ItpamParameterMissingOrInvalidException, ItpamStringToDateException,
	ItpamEntityNotFoundException, ItpamUserPermissionsException, ItpamUnknownHostException, ItpamWebServiceClientException
	{

		//	Initialize parameters object
		Params parameters = null;

		//	Iterate properties
		if (properties != null){

			//	Initialize and populate parameters object
			parameters = new Params();

			for (Iterator<Object> iKeys = properties.keySet().iterator(); iKeys.hasNext();){

				String strParameterName = (String) iKeys.next();
				String strParameterValue = properties.getProperty(strParameterName);

				//	Initialize new parameter
				Param parameter = new Param();
				parameter.setName(strParameterName);
				parameter.setString(strParameterValue);

				//	Add parameter
				parameters.addParam(parameter);
			}
		}

		//	Return parameters object
		return parameters;
	}

	/**
	 * Convert POJO Strings set to start request name and path to Location object
	 * 
	 * @param strStartRequestName - String set to start request name
	 * @param strStartRequestPathPath - String set to library path
	 * 
	 * @return version specific ITPAM Location object
	 * 
	 * @throws ItpamMethodNotSupportedException
	 * @throws ItpamParameterMissingOrInvalidException
	 * @throws ItpamStringToDateException
	 * @throws ItpamEntityNotFoundException
	 * @throws ItpamUserPermissionsException
	 * @throws ItpamUnknownHostException
	 * @throws ItpamWebServiceClientException
	 */
	private ObjLocation getInstanceOfLocation(String strStartRequestName, String strStartRequestPath)
	throws Exception, ItpamMethodNotSupportedException, ItpamParameterMissingOrInvalidException, ItpamStringToDateException,
	ItpamEntityNotFoundException, ItpamUserPermissionsException, ItpamUnknownHostException, ItpamWebServiceClientException
	{
		//	Initialize return object
		ObjLocation location = new ObjLocation();

		//	Update start request name and path fields
		this._strStartRequestName = strStartRequestName;
		this._strStartRequestPath = strStartRequestPath;

		//	Throw exception if missing or invalid detected otherwise update return object
		if ((this.isNullEmpty(strStartRequestName)) || (this.isNullEmpty(strStartRequestPath))){

			//	Set exception message
			String strMissingParms = "";
			if ((this.isNullEmpty(strStartRequestName))){

				this._strStartRequestName = "?";
				strMissingParms = "startRequestName";
			}
			if ((this.isNullEmpty(strStartRequestPath))){

				this._strStartRequestPath = "?";
				if (!this.isNullEmpty(strMissingParms)) strMissingParms = strMissingParms + ", ";
				strMissingParms = strMissingParms + "startRequestPath";
			}

			//	Set exception messages
			String strMessage = this._messages.get("E_MISSING_OR_INVALID_PARAMETER")
			+ " (" + strMissingParms + ")";
			String strLocalizedMessage = this._messages.getLocalized("E_MISSING_OR_INVALID_PARAMETER")
			+ " (" + strMissingParms + ")";;

			//	Record exception
			ItpamWebServiceClient.logger.error(strMessage);

			//	Throw exception
			throw new ItpamParameterMissingOrInvalidException(strMessage, strLocalizedMessage);
		}
		else {

			//	Append required trailing slash to path if needed
			if (!strStartRequestPath.endsWith("/")) {strStartRequestPath = strStartRequestPath + "/";}

			//	Set start request name and path
			this._strStartRequestName = strStartRequestName;
			this._strStartRequestPath = strStartRequestPath;

			//	Update object
			location.setName(strStartRequestName);
			location.setPath(strStartRequestPath);
		}

		//	Return location object
		return location;
	}	

	/**	Get string set to single line list of parameter name/value pairs encapsulated in parameters object specified.
	 * 
	 * @param parameters - Params object encapsulating parameter name/value pairs
	 * 
	 * @return String set to single line list of parameter name/value pairs encapsulated in parameters object specified
	 * 
	 * @throws ItpamMethodNotSupportedException
	 * @throws ItpamParameterMissingOrInvalidException
	 * @throws ItpamStringToDateException
	 * @throws ItpamEntityNotFoundException
	 * @throws ItpamUserPermissionsException
	 * @throws ItpamUnknownHostException
	 * @throws ItpamWebServiceClientException
	 */
	private String getParametersList(Params parameters)
	throws Exception, ItpamMethodNotSupportedException, ItpamParameterMissingOrInvalidException, ItpamStringToDateException,
	ItpamEntityNotFoundException, ItpamUserPermissionsException, ItpamUnknownHostException, ItpamWebServiceClientException
	{

		//	Initialize return string
		String strParametersList = "";

		//	Iterate parameters and build list
		if (parameters != null){

			if (parameters.getParam() != null) {

				for (int intParameter = 0; intParameter < parameters.getParam().length; intParameter++){

					if (!strParametersList.equals("")) strParametersList = strParametersList + " ";
					strParametersList = strParametersList + parameters.getParam()[intParameter].getName();
					strParametersList = strParametersList + "=";
					strParametersList = strParametersList + parameters.getParam()[intParameter].getString();
				}
			}
		}

		//	Return string
		return strParametersList;
	}

	/**	Private version specific concrete class extending public abstract class ItpamProceswsStatus						*/
	private class m_ItpamProcessStatus extends ItpamProcessStatus {

		/** Private String constant set to parameter/property name for "InstanceName"									*/
		private final String PARAM_NAME_DISPLAY_NAME = "DisplayName";

		/** Private String constant set to parameter/property name for "InstanceName"									*/
		private final String PARAM_NAME_INSTANCE_NAME = "InstanceName";

		/** Private String constant set to parameter/property name for "InstanceName"									*/
		private final String PARAM_NAME_PROCESS_NAME = "ProcessName";

		/**	Private instance of CheckFlowResult object																	*/
		private CheckFlowResult m_result = null;

		/**	Private instance of parameters Properties object															*/
		private Properties m_propertiesParameters = null;

		/**	Constructor @param result - CheckFlowResult object															*/
		public m_ItpamProcessStatus (CheckFlowResult result){

			super();
			this.m_result = result;
		}

		/** Get process connection ID. @return long set to process connection ID										*/
		public String getConnectionId(){

			return this.m_result.getConnectionId();
		}

		/**	Get process message. @return String set to process message													*/
		public String getMessage(){

			return this.m_result.getMessage();
		}

		/**	Get process status message. @return String set process status message										*/
		public String getMessageStatus(){

			return this.m_result.getMessageStatus();
		}

		/** Get process display name. @return String set to process display name										*/
		public String getProcessDisplayName(){

			//	Get parameters properties object
			Properties properties = this.getParameters();

			//	Return "InstanceName" property value
			return properties.getProperty(this.PARAM_NAME_DISPLAY_NAME);
		}

		/**	Get process ID. @return long set to process ID																*/
		public String getProcessId(){

			return this.m_result.getROID();
		}

		/** Get process instance specific name. @return String set to process instance specific name					*/
		public String getProcessInstanceName(){

			//	Get parameters properties object
			Properties properties = this.getParameters();

			//	Return "InstanceName" property value
			return properties.getProperty(PARAM_NAME_INSTANCE_NAME);
		}

		/**	Get fully qualified process library path and name. @return string set to fully qualified process library
		 * and name																										*/
		public String getProcessLibraryPathName(){

			//	Get parameters properties object
			Properties properties = this.getParameters();

			//	Return "InstanceName" property value
			return properties.getProperty(this.PARAM_NAME_PROCESS_NAME);
		}

		/** Get process state. @return String set to process state														*/
		public String getProcessState(){

			return this.m_result.getFlowState();
		}

		/**	Get process sender address. @return String set to process sender address									*/
		public String getSenderAddress(){

			return this.m_result.getSenderAddress();
		}

		/**	Get process submission time. @return String set to process submission time									*/
		public String getSubmissionTime(){

			return this.m_result.getSubmissionTime();
		}

		/**	Get process parameters. @return Properties object encapsulating process parameter names and values			*/
		public Properties getParameters(){

			//	Initialize properties if not yet initialized
			if (this.m_propertiesParameters == null){

				//	Initialize return object
				this.m_propertiesParameters = new Properties();

				//	Initialize parameters object
				Params parameters = this.m_result.getParams();

				//	Iterate parameters and set properties
				if (parameters != null){

					if (parameters.getParam() != null) {

						for (int intParameter = 0; intParameter < parameters.getParam().length; intParameter++){

							String strParameterName = parameters.getParam()[intParameter].getName();
							String strParameterValue = parameters.getParam()[intParameter].getString();
							this.m_propertiesParameters.setProperty(strParameterName, strParameterValue);
						}
					}
				}
			}			

			//	Return object
			return this.m_propertiesParameters;
		}
	};

	/**	Private version specific concrete class extending public abstract class ItpamStartRequestStatus					*/
	private class m_ItpamStartRequestStatus extends ItpamStartRequestStatus {

		/** Private version specific StartRequestStatus object reference												*/
		private StartRequestStatus m_status = null;

		/**	Constructor @param status - Version specific StartRequestStatus object										*/
		public m_ItpamStartRequestStatus(StartRequestStatus status){

			super();
			this.m_status = status;
		};

		/** Get start request status information @return String set to request earliest start date and time				*/
		public String getEarliestStartTime() {

			return this.m_status.getEarliestStartTime().getTime().toString();
		}

		/**	Get start request status information @return String set to request end date and time						*/
		public String getEndTime() {

			String strEndTime = null;

			if (this.m_status.getEndTime() != null) {

				strEndTime = this.m_status.getEndTime().getTime().toString();
			}

			return strEndTime;
		}

		/**	Get start request status information @return String set to request interaction ID value						*/
		public String getInteractionId() {

			return Long.toString(this.m_status.getInteractionId());
		}

		/**	Get start request status information @return String set to corresponding process ID value					*/
		public String getProcessId(){

			return Long.toString(this.m_status.getProcessID());

		}

		/**	Get start request status information @return String set to referenced process fully qualified name			*/
		public String getReferencedProcess() {

			return this.m_status.getRefProcess();
		}

		/**	Get start request status information @return String set to request start date and time						*/
		public String getStartTime() {

			return this.m_status.getStartTime().getTime().toString();
		}

		/**	Get start request status information @return String set to request state (ex. "Running")					*/
		public String getState(){

			return this.m_status.getState();
		}
	};

	/**
	 * Set an instance of a Process or Start Request Form to be archived.
	 * 
	 * @param rootUuid - String Root UUID
	 * @param instanceId - String Instance ID
	 * @param tagId - String Tag ID
	 * 
	 * @return controlInstanceStatus object encapsulating status properties
	 * 
	 * @throws ItpamEntityNotFoundException
	 * @throws ItpamMethodNotSupportedException
	 * @throws ItpamParameterMissingOrInvalidException
	 * @throws ItpamStringToDateException
	 * @throws ItpamUnknownHostException
	 * @throws ItpamUserPermissionsException
	 * @throws ItpamWebServiceClientException
	 */
	public  String controlInstance(String rootUuid, long instanceId, String tagId)
	throws Exception, ItpamMethodNotSupportedException, ItpamParameterMissingOrInvalidException, ItpamStringToDateException,
	ItpamEntityNotFoundException, ItpamUserPermissionsException, ItpamUnknownHostException, ItpamWebServiceClientException {	
		
		//	Record progress
		ItpamWebServiceClient.logger.debug("Calling controlInstance against PAM 4.0 stubs.");
		ItpamWebServiceClient.logger.debug("Control Instance using RootUUID " + rootUuid + " or InstanceID: " + instanceId + " or TagID: " + tagId);

		String status = "";
		String output = "";
		
		try {
			// initialize ControlInstance Object
			ControlInstance controlInst = new ControlInstance();
			controlInst.setAuth(this.m_auth_40);
			controlInst.setAction(ActionOnInstance.Factory.fromValue("archive"));
			
			ControlInstanceChoice_type0 choice = new ControlInstanceChoice_type0();
			if(rootUuid != null && rootUuid.length() > 0) {
				choice.setRootUUID(rootUuid);
				output = "RootUUID: " + rootUuid;
			} else if(instanceId != 0){
				choice.setInstanceId(instanceId);
				output = "InstanceID: " + instanceId;
			} else if(tagId != null && tagId.length() > 0) {
				choice.setTagId(tagId);
				output = "TagID: " + tagId;
			}
			
			controlInst.setControlInstanceChoice_type0(choice);

			//	Initiate web service request
			ControlInstanceResponse response = this.m_stubItpamService_40.controlInstance(controlInst);

			//	Initialize return object
			status = response.getActionStatus();

			//	Record success
			String strMessage = "Successfully completed request to control instance with " + output
				+ ". Status: " + status;
			ItpamWebServiceClient.logger.info(strMessage);
		}
		catch (Exception e) {

			try {
				//	Initialize exception messages
				String strMessage = this._messages.get("E_METHOD_CONTROL_INSTANCE")
				+ " (" + output + ")";
				String strLocalizedMessage = this._messages.getLocalized("E_METHOD_CONTROL_INSTANCE")
				+ " (" + output + ")";

				//	Get type specific exception
				e = this.getTypeSpecificException(e, strMessage, strLocalizedMessage);
			}
			catch (Exception eUnexpected){

				e = eUnexpected;
			}

			//	Record exception
			ItpamWebServiceClient.logger.error(e.getMessage());

			//	Throw specific exception type
			throw(e);
		}

		//	Return object
		return status;
	
	}

	
	/**
	 * Get current status of process specified.
	 * 
	 * @param lProcessId - long process ID value
	 * @param tagId - String tag Id value
	 * 
	 * @return ItpamProcessStatus object encapsulating status properties
	 * 
	 * @throws ItpamEntityNotFoundException
	 * @throws ItpamMethodNotSupportedException
	 * @throws ItpamParameterMissingOrInvalidException
	 * @throws ItpamStringToDateException
	 * @throws ItpamUnknownHostException
	 * @throws ItpamUserPermissionsException
	 * @throws ItpamWebServiceClientException
	 */
	public  ItpamProcessStatus getProcessStatus(long lProcessId, String tagId)
	throws Exception, ItpamMethodNotSupportedException, ItpamParameterMissingOrInvalidException, ItpamStringToDateException,
	ItpamEntityNotFoundException, ItpamUserPermissionsException, ItpamUnknownHostException, ItpamWebServiceClientException {			
		//	Record progress
		ItpamWebServiceClient.logger.debug("Calling getProcessStatus against PAM 4.0 stubs, input: tagId is taken into account.");
		ItpamWebServiceClient.logger.debug("Get process status using ID " + lProcessId + " or tagId " + tagId);

		//	Instantiate return object
		ItpamProcessStatus status = null;

		String output = "";
		try {

			//	Initialize flow object
			Execflow flow = new Execflow();
			flow.setAuth(this.m_auth_40);
			flow.setAction("Check");

			ExecflowChoice_type0 choice = new ExecflowChoice_type0();
			if(lProcessId != 0) {
				choice.setROID(String.valueOf(lProcessId));
				output = "process ID (" + lProcessId + ")";
			} else {
				choice.setTagId(tagId);
				output = "tag ID (" + tagId + ")";
			}
			flow.setExecflowChoice_type0(choice);

			//	Initialize request object
			GetProcessStatus request = new GetProcessStatus();
			request.setFlow(flow);

			//	Initiate web service request
			CheckFlowResponse response = this.m_stubItpamService_40.getProcessStatus(request);

			//	Initialize return object
			status = new m_ItpamProcessStatus(response.getCheckFlowResult());

			//	Record success
			String strMessage = "Successfully completed request to get status of process with " + output;
			ItpamWebServiceClient.logger.info(strMessage);
		}
		catch (Exception e) {

			try {
				//	Initialize exception messages
				String strMessage = this._messages.get("E_METHOD_GET_PROCESS_STATUS2")
				+ " " + output;
				String strLocalizedMessage = this._messages.getLocalized("E_METHOD_GET_PROCESS_STATUS2")
				+ " " + output;

				//	Get type specific exception
				e = this.getTypeSpecificException(e, strMessage, strLocalizedMessage);
			}
			catch (Exception eUnexpected){

				e = eUnexpected;
			}

			//	Record exception
			ItpamWebServiceClient.logger.error(e.getMessage());

			//	Throw specific exception type
			throw(e);
		}

		//	Return object
		return status;
	}	


	/**
	 * Get start request status object that includes the following information:
	 * <br>- Earliest Start Time
	 * <br>- End Time
	 * <br>- Interaction ID
	 * <br>- Referenced Process
	 * <br>- Start Time
	 * <br>- State
	 * 
	 * @param 1StartRequestInteractionId - long start request interaction ID value
	 * @param tagId - String tag ID
	 * 
	 * @return ItpamStartRequestStatus object that exposes methods to detailed status information
	 * 
	 * @throws ItpamMethodNotSupportedException
	 * @throws ItpamParameterMissingOrInvalidException
	 * @throws ItpamStringToDateException
	 * @throws ItpamEntityNotFoundException
	 * @throws ItpamUserPermissionsException
	 * @throws ItpamUnknownHostException
	 * @throws ItpamWebServiceClientException
	 */
	public ItpamStartRequestStatus getStartRequestStatus(long lStartRequestInteractionId, String tagId)
	throws Exception, ItpamMethodNotSupportedException, ItpamParameterMissingOrInvalidException, ItpamStringToDateException,
	ItpamEntityNotFoundException, ItpamUserPermissionsException, ItpamUnknownHostException, ItpamWebServiceClientException
	{
		//	Record progress
		ItpamWebServiceClient.logger.debug("Calling getStartRequestStatus against PAM 4.0 stubs, input: tagId is taken into account.");
		ItpamWebServiceClient.logger.debug("Get status for start request using either interaction ID " + lStartRequestInteractionId + "or tagId " + tagId);

		//	Initialize status object to be returned
		ItpamStartRequestStatus status = null;
		String output = "";
		
		try {

			//	Initialize request object
			CheckStartRequestStatus request = new CheckStartRequestStatus();
			request.setAuth(this.m_auth_40);
			
			CheckStartRequestStatusChoice_type0 choice = new CheckStartRequestStatusChoice_type0();
			
			if(lStartRequestInteractionId != 0) {
				//	Initialize ID object
				Id id = new Id();
				id.setId(lStartRequestInteractionId);
				choice.setInteractionId(id);
				output = "interaction ID (" + lStartRequestInteractionId + ")";
			} else {
				choice.setTagId(tagId);
				output = "tag ID (" + tagId + ")";
			}
			
			request.setCheckStartRequestStatusChoice_type0(choice);

			//	Initiate web service request
			CheckStartRequestStatusResponse response = this.m_stubItpamService_40.checkStartRequestStatus(request);

			//	Update status object to be returned
			status = new m_ItpamStartRequestStatus(response.getStartRequestStatus());

			//	Record success
			String strMessage = "Successfully completed request to get status for start request with " + output;
			ItpamWebServiceClient.logger.info(strMessage);
		}
		catch (Exception e) {

			try {
				//	Initialize exception messages
				String strMessage = this._messages.get("E_METHOD_GET_START_REQUEST_STATUS2")
				+ " " + output;
				String strLocalizedMessage = this._messages.getLocalized("E_METHOD_GET_START_REQUEST_STATUS2")
				+ " " + output;

				//	Get type specific exception
				e = this.getTypeSpecificException(e, strMessage, strLocalizedMessage);
			}
			catch (Exception eUnexpected){

				e = eUnexpected;
			}

			//	Record exception
			ItpamWebServiceClient.logger.error(e.getMessage());

			//	Throw specific exception type
			throw(e);
		}

		//	Return status object
		return status;
	}


}
